# fna_bw.tcl:  Basic widget set.
# RCS Id: $Id: fna_bw.tcl,v 1.0.0.2 1997/01/09 03:46:46 ndanger Alpha $

# fna:bw_version:  Return the version of this file.

proc fna:bw_version {} {
  return [fna:ver_rcs {$Revision: 1.0.0.2 $} {$State: Alpha $}]
}


proc _fna:bw_entrybox {w lbl orient type typecon} {
  global FNA
  
  frame $w
  $type $w.la -text "$lbl"
  entry $w.en -relief sunken
  
  if {$orient == "hor"} {
    pack $w.la -side left
    pack $w.en -side right -fill x -expand 0
  } \
  else {
    pack $w.la -side top
    pack $w.en -side bottom -fill x -expand 0
  }
  
  if {[catch "rename $w ${w}_cmd"]} {rename ${w}_cmd "" ; rename $w ${w}_cmd}
    proc $w {args} "
    	if \{\"$type\" == \[lindex \$args 0\]\} \{return $w.la\}
    	if \{\[lindex \$args 0\] == \"entry\"\} \{return $w.en\}
        if \{\[lindex \$args 0\] == \"econfigure\"\} \{return \[eval $w.en configure \[lrange \$args 1 end\]\]\}
        if \{\[lindex \$args 0\] == \"$typecon\"\} \{return \[eval $w.la configure \[lrange \$args 1 end\]\]\}
    	return \[eval \"${w}_cmd \" \$args\]
    "
  
  return ""
  
}


proc fna:bw_uniquesubwindow {w p} {
	
	set i 0
	while {[winfo exists $w.$p$i]} {incr i}
	return "$w.$p$i"
	
}


proc fna:bw_labelentry {w lbl {orient {hor}} {entryargs {}} {labelargs {}} } {
  _fna:bw_entrybox $w $lbl $orient label lconfigure
  if {$entryargs != ""} {eval $w econfigure $entryargs}
  if {$labelargs != ""} {eval $w lconfigure $labelargs}
  return $w
}


proc fna:bw_buttonentry {w lbl {orient {hor}} {entryargs {}} {buttonargs {}} } {
  _fna:bw_entrybox $w $lbl $orient button bconfigure
  if {$entryargs != ""} {eval $w econfigure $entryargs}
  if {$buttonargs != ""} {eval $w bconfigure $buttonargs}
  return $w
}


proc fna:bw_mbentry {w lbl {orient {hor}} {entryargs {}} {mbargs {}} } {
  _fna:bw_entrybox $w $lbl $orient menubutton mbconfigure
  if {$entryargs != ""} {eval $w econfigure $entryargs}
  if {$mbargs != ""} {eval $w mbconfigure $mbargs}
  set mnu [$w menubutton].m
  menu $mnu
  $w mbconfigure -menu $mnu
  
  set curproc [info body $w]
  proc $w {args} "
    if \{\[lindex \$args 0\] == \"menu\"\} \{return $mnu\}
    $curproc
  "
  
  return $w
}


proc fna:bw_scrolllistbox {w {lbargs {}} {sbxargs {}} {sbyargs {}}} {
    
    frame $w

    scrollbar $w.sbx -orient hor -relief sunken
    scrollbar $w.sby -orient ver -relief sunken
    listbox $w.lb

    pack $w.sbx -side bottom -fill x
    pack $w.sby -side left -fill y
    pack $w.lb -side left -fill both -expand yes

    $w.lb configure -yscrollcommand "$w.sby set" -xscrollcommand "$w.sbx set"
    $w.sby configure -command "$w.lb yview"
    $w.sbx configure -command "$w.lb xview"
    
    if {[catch "rename $w ${w}_cmd"]} {rename ${w}_cmd "" ; rename $w ${w}_cmd}
    proc $w {args} "
    	if \{\"listbox\" == \[lindex \$args 0\]\} \{return $w.lb\}
    	if \{\"scrollx\" == \[lindex \$args 0\]\} \{return $w.sbx\}
    	if \{\"scrolly\" == \[lindex \$args 0\]\} \{return $w.sby\}
    	return \[eval \"${w}_cmd \" \$args\]
    "
    
    if {$lbargs != ""} {eval [$w listbox] configure $lbargs}
    if {$sbxargs != ""} {eval [$w scrollx] configure $sbxargs}
    if {$sbyargs != ""} {eval [$w scrolly] configure $sbyargs}
        
    return $w

}


proc fna:bw_scrolltext {w {textargs {}} {sbargs {}} } {

    frame $w

    scrollbar $w.sby -orient ver -relief sunken
    text $w.text

    pack $w.sby -side left -fill y
    pack $w.text -side left -fill y -expand yes

    $w.text configure -yscrollcommand "$w.sby set"
    $w.sby configure -command "$w.text yview"

    if {[catch "rename $w ${w}_cmd"]} {rename ${w}_cmd "" ; rename $w ${w}_cmd}
    proc $w {args} "
    	if \{\"text\" == \[lindex \$args 0\]\} \{return $w.text\}
    	if \{\"scrolly\" == \[lindex \$args 0\]\} \{return $w.sby\}
    	return \[eval \"${w}_cmd \" \$args\]
    "

    if {$textargs != ""} {eval [$w text] configure $textargs}
    if {$sbargs != ""} {eval [$w scrolly] configure $sbargs}

    return $w

}
